//
//  BEBBCView.m
//  BeebEmX
//
//  Created by Steven Bagley on 30/04/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#import "BEBBCView.h"

@implementation BEBBCView

-(BEBBCView*)initWithFrame:(NSRect)frame
{

    self = [super initWithFrame:frame];
    
    if(self)
    {
        CALayer *theLayer;
        NSLog(@"Created BBC View");

        /* Create layer */
        [self setWantsLayer:YES];
        theLayer = [CALayer layer];
        self.layer = theLayer;
        theLayer.frame = NSMakeRect(0,0,frame.size.width, frame.size.height);
        
        _displayLayer = [CALayer layer];
        [theLayer addSublayer:_displayLayer];
        _displayLayer.frame = NSMakeRect(0,0,frame.size.width, frame.size.height);
        
        

        CGColorSpaceRef devRGB = CGColorSpaceCreateDeviceRGB();
        _bbcBitmap = CGBitmapContextCreate(NULL, 768, 576, 8, 0, devRGB, kCGImageAlphaNoneSkipLast|kCGBitmapByteOrder32Host);
        CGColorSpaceRelease(devRGB);
        
        _blue = 0;
        [self fillImage];
        
        CGImageRef img = CGBitmapContextCreateImage(_bbcBitmap);
 //       _displayLayer.contents = (id)img;

        
        CGImageRelease(img);

        
        
    }
    
    return self;
    
}

-(void)fillImage
{
    unsigned char *p;
    int x,y;
    p = (unsigned char *)CGBitmapContextGetData(_bbcBitmap);
    for(y = 0; y < 576; y++)
    {
        for(x = 0; x < 768; x++)
        {
            *p++ = 0;
            *p++ = 0xFF * (x / 768.0);
            *p++ = 0xff;
            *p++ = _blue;
            
        }
    }
    
    _blue++;
    if(_blue > 255)
    {
        _blue = 0;
    }
}

-(void)fillWithFrame:(CBeebFrame*)frame
{
    static unsigned int beebPalette[] =
    {
        /* ABGR */
        0x00000000,  /* Black */
        0xFF000000,  /* Red */
        0x00FF0000,  /* Green */
        0xFFFF0000,  /* Yellow */
        0x0000FF00,  /* Blue */
        0xFF00FF00,  /* Magenta */
        0x00FFFF00,  /* Cyan */
        0xFFFFFF00   /* White */
    };
    
    unsigned int *p = (unsigned int *)CGBitmapContextGetData(_bbcBitmap);
    unsigned char *q = frame->Data();
    int i;
    
    for(i = 0; i < 768*576; i++)
    {
        *p++ = beebPalette[*q++];
        
    }
    
    
//    memcpy(CGBitmapContextGetData(_bbcBitmap), frame->Data(), 768*576);
    CGImageRef img = CGBitmapContextCreateImage(_bbcBitmap);
    
//    _displayLayer.contents = (id)img;
    [_displayLayer performSelectorOnMainThread:@selector(setContents:) withObject:(id)img waitUntilDone:YES];
    
    CGImageRelease(img);
}


#if 0
- (void)drawRect:(NSRect)dirtyRect
{
    CGContextRef ctx;
    CGImageRef img;
    
    /* Get the graphics port */
    ctx = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];

    
    /* This is a big hack */
    
    /* Get an image */
    img = CGBitmapContextCreateImage(_bbcBitmap);
    
    CGContextDrawImage(ctx, CGRectMake(0,0,768,576), img);
    
    
    CGImageRelease(img);
}
#endif



@end
