//
//  BEEmulator.h
//  BeebEmX
//
//  Created by Steven Bagley on 20/04/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#import <Foundation/Foundation.h>
#include "FrameQueue.h"

class CBeebEm;
class CBeebMemory;

@interface BEEmulator : NSThread
{
    NSCondition *_condition;
    double _runToTime;
    CBeebEm *_beeb;
    CBeebMemory *_beebMemory;
    EMVIDEOLINK *_vlink;
    NSLock *_emulatorLock;
    unsigned int _previousModifiers;
}

-(BEEmulator*)initWithVideoLink:(EMVIDEOLINK *)vlink;

-(void)main;

-(void)loadDisk:(NSURL*)url;

-(void)runForPeriod:(double)time;
-(void)runToTime:(double)time;

-(void)keyDown:(unsigned short)keyCode;
-(void)keyUp:(unsigned short)keyCode;
-(void)flagsChanged:(unsigned int)modifiers;

@end
