//
//  BeebEmulator.cpp
//  BeebEmX
//
//  Created by Steven Bagley on 13/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#include "BeebEm.h"
#include "BeebMemory.h"
#include "Beeb1770DiscInterface.h"

#include "6502core.h"

#include "sysvia.h"
#include "uservia.h"

#include "tube.h"
#include "video.h"
#include "beebmem.h"
#include "beebsound.h"
#include "disc1770.h"


CBeebEm *machine = NULL;


void CBeebEm::Initialise(EMVIDEOLINK *vlink)
{
    
    TubeEnabled = 0;
    m_machineType = 0;
    VideoLink = vlink;
    
    m_memory = new CBeebMemory();
}

#if 0
void CBeebEm::InitialiseMemory()
{
    int bank;
    
    BeebMemInit(false, true);
    
    // Clear ROMs
    for (bank = 0; bank < 16; bank++)
    {
        RomWritable[bank] = 0;
        RomBankType[bank] = BankEmpty;
        memset(Roms[bank], 0, 0x4000);
    }
    
}
#endif

void CBeebEm::Reset(/*unsigned char NewModelType, unsigned char TubeStatus, unsigned char LoadRoms*/)
{
    SwitchOnCycles = 0; // Reset delay
    SoundReset();
    if (SoundDefault)
    {
        SoundInit();
    }
    SwitchOnSound();
    
    
#if 0
    EnableTube = TubeStatus;
    MachineType = NewModelType;
#endif
    
    
    /* SRB HACK */
    
    /* Put first ROM in */
    m_memory->SetSWR(15);
    
    Init6502core(m_memory);
#if 0
    if (EnableTube) Init65C02core();
#endif
#ifdef M512COPRO_ENABLED
    if (Tube186Enabled) i86_main();
#endif
#if 0
    Enable_Z80 = 0;
    if (TorchTube || AcornZ80)
    {
        R1Status = 0;
        ResetTube();
        init_z80();
        Enable_Z80 = 1;
    }
    Enable_Arm = 0;
    if (ArmTube)
    {
        R1Status = 0;
        ResetTube();
        if (arm)
        {
            delete arm;
        }
        
        arm = new CArm;
        Enable_Arm = 1;
    }
#endif
    
    SysVIAReset();
    UserVIAReset();
    VideoInit(m_memory);
    Reset1770();
    
#if 0
    SetDiscWriteProtects();
    Disc8271_reset();
    if (EconetEnabled) EconetReset();	//Rob:
    AtoDInit();
    SetRomMenu();
    FreeDiscImage(0);
    // Keep the disc images loaded
    FreeDiscImage(1);
    Close1770Disc(0);
    Close1770Disc(1);
    if (SCSIDriveEnabled) SCSIReset();
    if (SCSIDriveEnabled) SASIReset();
    if (IDEDriveEnabled)  IDEReset();
    TeleTextInit();
    if (MachineType==3) InvertTR00=FALSE;
    if (MachineType!=3)
    {
        LoadFDC(NULL, false);
    }
    if ((MachineType != 3) && (NativeFDC))
    {
        // 8271 disc
        if ((DiscLoaded[0]) && (CDiscType[0]==0)) LoadSimpleDiscImage(CDiscName[0],0,0,80);
        if ((DiscLoaded[0]) && (CDiscType[0]==1)) LoadSimpleDSDiscImage(CDiscName[0],0,80);
        if ((DiscLoaded[1]) && (CDiscType[1]==0)) LoadSimpleDiscImage(CDiscName[1],1,0,80);
        if ((DiscLoaded[1]) && (CDiscType[1]==1)) LoadSimpleDSDiscImage(CDiscName[1],1,80);
    }
    
    if (((MachineType!=3) && (!NativeFDC)) || (MachineType==3))
    {
        // 1770 Disc
        if (DiscLoaded[0]) Load1770DiscImage(CDiscName[0],0,CDiscType[0],m_hMenu);
        if (DiscLoaded[1]) Load1770DiscImage(CDiscName[1],1,CDiscType[1],m_hMenu);
    }
#endif
}

#if 0
void CBeebEm::LoadRom(int romPosition, const void *data, unsigned int size)
{
    if(romPosition >= 0 && romPosition < 16)
    {
        RomWritable[romPosition] = 0;
        RomBankType[romPosition] = BankRom;
        
        /* Copy ROM image */
        memcpy(Roms[romPosition], data, size < 16384 ? size : 16384);
    }
}

void CBeebEm::LoadOSRom(const void *data, unsigned int size)
{
    memcpy(WholeRam + 0xC000, data, size < 16384 ? size : 16384);
}
#endif
void CBeebEm::LoadMode7Font(const unsigned char *fontData)
{
    BuildMode7Font(fontData);
}

void CBeebEm::Set1770DFS()
{
    CBeeb1770DiscInterface *ssDisk = new CBeeb1770DiscInterface(false);
    
    ssDisk->Register(m_memory);
    
    InvertTR00 = false;
#if 0
    NativeFDC = false;
    EFDCAddr = 0xfe84;
    EDCAddr = 0xfe80;
#endif
}

void CBeebEm::LoadDisc(char *path, int DscDrive, int DscType)
{
    Load1770DiscImage(path, DscDrive, DscType /*,HMENU dmenu*/);
}

void CBeebEm::EjectDisc(int drive)
{
    Close1770Disc(drive);
}

void CBeebEm::Tick()
{
    Exec6502Instruction();
}

long  CBeebEm::CyclesExecuted()
{
    return TotalCycles;
}

void CBeebEm::KeyDown(int row, int col)
{
    BeebKeyDown(row, col);
}

void CBeebEm::KeyUp(int row, int col)
{
    BeebKeyUp(row, col);
}




