//
//  BeebEmulator.h
//  BeebEmX
//
//  Created by Steven Bagley on 13/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#ifndef __BeebEmX__BeebEmulator__
#define __BeebEmX__BeebEmulator__

#include <stdio.h>
#include "FrameQueue.h"

class CBeebEm;
class CBeebMemory;

extern CBeebEm *machine;


class CBeebEm
{
public:
    CBeebEm() : m_machineType(0)
    {
        machine = this;
    }
    
    ~CBeebEm()
    {
        
        
    }
    
    void Initialise(EMVIDEOLINK *vlink);
    void InitialiseMemory();
    
    void Reset();
    
    void Tick();
    long CyclesExecuted();
    
    void LoadRom(int romPosition, const void *data, unsigned int size);
    void LoadOSRom(const void *data, unsigned int size);
    void LoadMode7Font(const unsigned char *fontData);
    void Set1770DFS();
    void LoadDisc(char *path, int DscDrive, int DscType);
    void EjectDisc(int drive);
    inline const int MachineType() { return m_machineType; }
    void KeyDown(int row, int col);
    void KeyUp(int row, int col);

    CBeebMemory *Memory() { return m_memory; }
    
private:
    int m_machineType;
    CBeebMemory *m_memory;
    
    
};



#endif /* defined(__BeebEmX__BeebEmulator__) */
