//
//  Beeb1770DiscInterface.cpp
//  BeebEmX
//
//  Created by Steven Bagley on 16/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#include "BeebMemory.h"
#include "Beeb1770DiscInterface.h"
#include "SheilaMemory.h"
#include "disc1770.h"


CBeeb1770DiscInterface::CBeeb1770DiscInterface(bool master) : m_master(master)
{
    
    m_fdcAddress  = m_master ? 0xfe24 : 0xfe80;
    m_1770Address = m_master ? 0xfe28 : 0xfe84;
}

void CBeeb1770DiscInterface::Register(CBeebMemory *mem)
{
    mem->RegisterDevice(m_fdcAddress, this);
    mem->RegisterDevice(m_1770Address + 0, this);
    mem->RegisterDevice(m_1770Address + 1, this);
    mem->RegisterDevice(m_1770Address + 2, this);
    mem->RegisterDevice(m_1770Address + 3, this);
    
    
}




int CBeeb1770DiscInterface::ReadByte(const int address)
{
    
#if 0
    // Master uses fe24 to fe2f for FDC
    if (address==0xfe24 && MachineType==3) {
        return(ReadFDCControlReg());
    }
    
    }
#endif

    if ((address & ~3) == m_1770Address)
    {
        return(Read1770Register(address & 0x3));
    }

    if(address == m_fdcAddress)
    {
        unsigned char temp, temp2;
        temp = ReadFDCControlReg();
        
        if(m_master)
        {
            return temp;
        }
        else
        {
            // from master 128 to B+
            
            temp2 = temp & 3; // drive selects
            temp2 |= (temp & 48) >> 2; // side and density selects
            
            return temp2;
        }
    }

    
    return 0xFF;
}

void CBeeb1770DiscInterface::WriteByte(const int address, const unsigned char value)
{
    if (address == m_fdcAddress)
    {
        if(m_master)
        {
            WriteFDCControlReg(value);
        }
        else
        {
            unsigned char temp;

            /* Nicked from Acorn DLL */
            // from native to master 128
            temp  =  value & 3;         // drive selects
            temp |= (value & 12) << 2;  // Side select and density select
            temp |= (value & 32) >> 3;  // Reset
            
            WriteFDCControlReg(temp);
        }
        return;
    }

    if((address & ~0x3) == m_1770Address)
    {
        Write1770Register(address & 3, value);
        return;
    }

    
}