//
//  CoreAudioStreamer.cpp
//  BeebEmX
//
//  Created by Steven Bagley on 18/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

//#include <CoreAudio/CoreAudio.h>
#include "CoreAudioStreamer.h"
#include <math.h>



CCoreAudioStreamer::CCoreAudioStreamer()
{
    int i;
    OSStatus err;
    static struct AudioStreamBasicDescription format = {44100.0, kAudioFormatLinearPCM, kLinearPCMFormatFlagIsSignedInteger|kAudioFormatFlagIsPacked, 1, 1, 1, 1 , 8, 0};
    
    m_sampleBuffer = (char*)malloc(kNumBuffers * kBufferSize);
    memset(m_sampleBuffer, 0, kNumBuffers * kBufferSize);
    
    m_circularSamples[0] = m_sampleBuffer;
    m_circularSamples[1] = m_sampleBuffer + kBufferSize;
    m_circularSamples[2] = m_sampleBuffer + kBufferSize*2;
    m_record = m_playback = 0;
    
    err = AudioQueueNewOutput(&format, &CCoreAudioStreamer::HandleOutputBuffer, this, CFRunLoopGetCurrent(), kCFRunLoopCommonModes, 0, &m_audioQueue);
    if(noErr == err)
    {
        for(i = 0; i < kNumBuffers; i++)
        {
            err = AudioQueueAllocateBuffer(m_audioQueue, kBufferSize, &m_audioBuffers[i]);
            if(err != noErr)
            {
                fprintf(stderr,"failed");
            }
            HandleOutputBuffer(this, m_audioQueue, m_audioBuffers[i]);
        }
        
        m_record = (m_playback + 1) % kNumBuffers;
        AudioQueueStart(m_audioQueue, NULL);
        
    }
}

CCoreAudioStreamer::~CCoreAudioStreamer()
{
    
}

size_t CCoreAudioStreamer::BufferSize() const
{
    return kBufferSize;
}

void CCoreAudioStreamer::Play()
{
    
    
}

void CCoreAudioStreamer::Pause()
{
    
    
}

void CCoreAudioStreamer::Stream( void const *pSamples )
{
//    fwrite(pSamples, 1, 44100 * 20 / 1000, m_fp);
    
    memcpy(m_circularSamples[m_record], pSamples, kBufferSize);
    m_playback = m_record;
    m_record = (m_record + 1) % kNumBuffers;
}

void CCoreAudioStreamer::HandleOutputBuffer(void *aqData, AudioQueueRef inAQ, AudioQueueBufferRef inBuffer)
{
    CCoreAudioStreamer *ps = (CCoreAudioStreamer*)aqData;
    char *p = (char *)inBuffer->mAudioData;
    
    memcpy(p, ps->m_circularSamples[ps->m_playback], kBufferSize);
//    ps->m_playback = (ps->m_playback + 1) % kNumBuffers;
    
    inBuffer->mAudioDataByteSize = kBufferSize;
    AudioQueueEnqueueBuffer(inAQ, inBuffer, 0, NULL);
    
}
