//
//  CoreAudioStreamer.h
//  BeebEmX
//
//  Created by Steven Bagley on 18/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#ifndef __BeebEmX__CoreAudioStreamer__
#define __BeebEmX__CoreAudioStreamer__

#include <stdio.h>
//#include <CoreAudio/CoreAudio.h>
#include <AudioToolbox/AudioToolbox.h>

#include "SoundStreamer.h"

const int kBufferSize = 44100 * 50 /1000;
const int kNumBuffers = 3;

class CCoreAudioStreamer : public SoundStreamer
{
public:
    CCoreAudioStreamer();
    virtual ~CCoreAudioStreamer();
    
    virtual size_t BufferSize() const;
    virtual void Play();
    virtual void Pause();
    
    virtual void Stream( void const *pSamples );

private:
    
    AudioQueueRef m_audioQueue;
    AudioQueueBufferRef m_audioBuffers[3];
    static void HandleOutputBuffer(void *aqData, AudioQueueRef inAQ, AudioQueueBufferRef inBuffer);
    
    char *m_sampleBuffer;
    char *m_circularSamples[3];
    int m_record, m_playback;
    
};

#endif /* defined(__BeebEmX__CoreAudioStreamer__) */
