//
//  SoundSample.cpp
//  BeebEmX
//
//  Created by Steven Bagley on 18/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#include "SoundSample.h"

static SoundSample SoundSamples[] =
{
    { "RelayOn.snd", NULL, 0, 0, false, false },
    { "RelayOff.snd", NULL, 0, 0, false, false },
    { "DriveMotor.snd", NULL, 0, 0, false, false },
    { "HeadLoad.snd", NULL, 0, 0, false, false },
    { "HeadUnload.snd", NULL, 0, 0, false, false },
    { "HeadSeek.snd", NULL, 0, 0, false, false },
    { "HeadStep.snd", NULL, 0, 0, false, false }
};

#define NUM_SOUND_SAMPLES (sizeof(SoundSamples)/sizeof(SoundSample))
static bool SoundSamplesLoaded = false;
int RelaySoundEnabled = 0;
int DiscDriveSoundEnabled = 0;


void ClickRelay(unsigned char RState)
{
    if (RelaySoundEnabled)
    {
        if (RState)
        {
            SoundSamples[SAMPLE_RELAY_ON].pos = 0;
            SoundSamples[SAMPLE_RELAY_ON].playing = true;
        }
        else {
            SoundSamples[SAMPLE_RELAY_OFF].pos = 0;
            SoundSamples[SAMPLE_RELAY_OFF].playing = true;
        }
    }
}

void PlaySoundSample(int sample, bool repeat) {
    SoundSamples[sample].pos = 0;
    SoundSamples[sample].playing = true;
    SoundSamples[sample].repeat = repeat;
}

void StopSoundSample(int sample) {
    SoundSamples[sample].playing = false;
}

void LoadSoundSamples(void)
{
#if 0
    FILE *fd;
    char FileName[256];
    int i;
    
    if (!SoundSamplesLoaded) {
        for (i = 0; i < NUM_SOUND_SAMPLES; ++i) {
            strcpy(FileName, mainWin->GetAppPath());
            strcat(FileName, SoundSamples[i].pFilename);
            fd = fopen(FileName, "rb");
            if (fd != NULL) {
                fseek(fd, 0, SEEK_END);
                SoundSamples[i].len = ftell(fd);
                SoundSamples[i].pBuf = (unsigned char *)malloc(SoundSamples[i].len);
                fseek(fd, 0, SEEK_SET);
                fread(SoundSamples[i].pBuf, 1, SoundSamples[i].len, fd);
                fclose(fd);
            }
            else {
                char errstr[200];
                sprintf(errstr,"Could not open sound sample file:\n  %s", FileName);
                MessageBox(GETHWND,errstr,WindowTitle,MB_OK|MB_ICONERROR);
            }
        }
        SoundSamplesLoaded = true;
    }
#endif
}