//
//  SoundSample.h
//  BeebEmX
//
//  Created by Steven Bagley on 18/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#ifndef __BeebEmX__SoundSample__
#define __BeebEmX__SoundSample__

#include <stdio.h>

struct SoundSample
{
    const char *pFilename;
    unsigned char *pBuf;
    int len;
    int pos;
    bool playing;
    bool repeat;
};

void ClickRelay(unsigned char RState);

#define SAMPLE_RELAY_ON         0
#define SAMPLE_RELAY_OFF        1
#define SAMPLE_DRIVE_MOTOR      2
#define SAMPLE_HEAD_LOAD        3
#define SAMPLE_HEAD_UNLOAD      4
#define SAMPLE_HEAD_SEEK        5
#define SAMPLE_HEAD_STEP        6
#define SAMPLE_HEAD_SEEK_CYCLES_PER_TRACK  48333  // 0.02415s per track in the sound file
#define SAMPLE_HEAD_STEP_CYCLES           100000  // 0.05s sound file
#define SAMPLE_HEAD_LOAD_CYCLES           400000  // 0.2s sound file
void PlaySoundSample(int sample, bool repeat);
void StopSoundSample(int sample);



#endif /* defined(__BeebEmX__SoundSample__) */
