//
//  VideoState.h
//  BeebEmX
//
//  Created by Steven Bagley on 24/05/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#ifndef BeebEmX_VideoState_h
#define BeebEmX_VideoState_h

/* CharLine counts from the 'reference point' - i.e. the point at which we reset the address pointer - NOT
 the point of the sync. If it is -ve its actually in the adjust time */
typedef struct
{
    int Addr;       /* Address of start of next visible character line in beeb memory  - raw */
    int StartAddr;  /* Address of start of first character line in beeb memory  - raw */
    int PixmapLine; /* Current line in the pixmap */
    int FirstPixmapLine; /* The first pixmap line where something is visible.  Used to eliminate the
                          blank virtical retrace lines at the top of the screen.  */
    int PreviousFirstPixmapLine; /* The first pixmap line on the previous frame */
    int LastPixmapLine; /* The last pixmap line where something is visible.  Used to eliminate the
                         blank virtical retrace lines at the bottom of the screen.  */
    int PreviousLastPixmapLine; /* The last pixmap line on the previous frame */
    int IsTeletext; /* This frame is a teletext frame - do things differently */
    unsigned char *DataPtr;  /* Pointer into host memory of video data */
    
    int CharLine;   /* 6845 counts in characters vertically - 0 at the top , incs by 1 - -1 means we are in the bit before the actual display starts */
    int InCharLineUp; /* Scanline within a character line - counts up*/
    int VSyncState; // Cannot =0 in MSVC $NRM; /* When >0 VSync is high */
    int IsNewTVFrame; /* Specifies the start of a new TV frame, following VSync (used so we only calibrate speed once per frame) */
} VideoStateT;

#endif
