//
//  beebwin_windows.cpp
//  BeebEmX
//
//  Created by Steven Bagley on 20/04/2015.
//  Copyright (c) 2015 Brokentooth. All rights reserved.
//

#include <stdio.h>


void BeebWin::ShowMenu(bool on)
{
    if (DisableMenu)
        on=FALSE;
    
    if (on!=MenuOn) {
        if (on)
            SetMenu(m_hWnd, m_hMenu);
        else
            SetMenu(m_hWnd, NULL);
    }
    MenuOn=on;
}

void BeebWin::TrackPopupMenu(int x, int y) {
    ::TrackPopupMenu(m_hMenu, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON,
                     x, y,
                     0,
                     m_hWnd,
                     NULL);
}

/****************************************************************************/
void BeebWin::InitMenu(void)
{
#if 0
    char menu_string[256];
    HMENU hMenu = m_hMenu;
    
    // File -> Video Options
    CheckMenuItem(hMenu, IDM_VIDEORES1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEORES2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEORES3, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP0, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP3, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP4, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_VIDEOSKIP5, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_CHECKED);
    CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_CHECKED);
    
    // File -> Disc Options
    CheckMenuItem(hMenu, IDM_WPDISC0, m_WriteProtectDisc[0] ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_WPDISC1, m_WriteProtectDisc[1] ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_WPONLOAD, m_WriteProtectOnLoad ? MF_CHECKED : MF_UNCHECKED);
    
    // File -> Capture Options
    CheckMenuItem(hMenu, IDM_CAPTURERES1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTURERES2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTURERES3, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTUREBMP, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTUREJPEG, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTUREGIF, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_CAPTUREPNG, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdCaptureResolution, MF_CHECKED);
    CheckMenuItem(hMenu, m_MenuIdCaptureFormat, MF_CHECKED);
    
    // Edit
    CheckMenuItem(hMenu, IDM_EDIT_CRLF, m_translateCRLF ? MF_CHECKED : MF_UNCHECKED);
    
    // Comms -> Tape Speed
    SetTapeSpeedMenu();
    
    // Comms
    CheckMenuItem(m_hMenu,ID_UNLOCKTAPE,(UnlockTape)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTERONOFF, PrinterEnabled ? MF_CHECKED : MF_UNCHECKED);
    
    // Comms -> Printer
    CheckMenuItem(hMenu, IDM_PRINTER_FILE, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_LPT1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_LPT2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_LPT3, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_LPT4, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_COM1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_COM2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_COM3, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_PRINTER_COM4, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
    strcpy(menu_string, "File: ");
    strcat(menu_string, m_PrinterFileName);
    ModifyMenu(hMenu, IDM_PRINTER_FILE, MF_BYCOMMAND, IDM_PRINTER_FILE, menu_string);
    
    // Comms -> RS423
    CheckMenuItem(hMenu, ID_SERIAL, SerialPortEnabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM1, (SerialPort==1)? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM2, (SerialPort==2)? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM3, (SerialPort==3)? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM4, (SerialPort==4)? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_TOUCHSCREEN, TouchScreenEnabled ? MF_CHECKED:MF_UNCHECKED);
    //	CheckMenuItem(hMenu, ID_IP232, EthernetPortEnabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232LOCALHOST, IP232localhost ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232CUSTOM, IP232custom ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232MODE, IP232mode ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232RAW, IP232raw ? MF_CHECKED:MF_UNCHECKED);
    
    // View
    UpdateDisplayRendererMenu();
    CheckMenuItem(hMenu, IDM_DXSMOOTHING, m_DXSmoothing ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_DXSMOOTHMODE7ONLY, m_DXSmoothMode7Only ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_SPEEDANDFPS, m_ShowSpeedAndFPS ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FULLSCREEN, m_isFullScreen ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_MAINTAINASPECTRATIO, m_MaintainAspectRatio ? MF_CHECKED : MF_UNCHECKED);
    UpdateMonitorMenu();
    CheckMenuItem(hMenu, ID_HIDEMENU, HideMenuEnabled ? MF_CHECKED:MF_UNCHECKED);
    UpdateLEDMenu(hMenu);
    CheckMenuItem(hMenu, IDM_TEXTVIEW, m_TextViewEnabled ? MF_CHECKED:MF_UNCHECKED);
    
    // View -> Win size
    CheckMenuItem(hMenu, IDM_320X256, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_640X512, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_800X600, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1024X768, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1024X512, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1280X1024, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1440X1080, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1600X1200, MF_UNCHECKED);
    //CheckMenuItem(hMenu, m_MenuIdWinSize, MF_CHECKED);
    
    // View -> DD mode
    CheckMenuItem(hMenu, ID_VIEW_DD_640X480, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_720X576, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_800X600, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1024X768, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1280X720, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1280X1024, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1280X768, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1280X960, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1440X900, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1600X1200, MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_VIEW_DD_1920X1080, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_DDFullScreenMode, MF_CHECKED);
    
    // View -> Motion blur
    CheckMenuItem(hMenu, IDM_BLUR_OFF, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_BLUR_2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_BLUR_4, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_BLUR_8, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MotionBlur, MF_CHECKED);
    
    // Speed
    CheckMenuItem(hMenu, IDM_REALTIME, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED100, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED50, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED10, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED5, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED2, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED1_5, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED1_25, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED1_1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED0_9, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED0_5, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED0_75, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED0_25, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FIXEDSPEED0_1, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_50FPS, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_25FPS, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_10FPS, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_5FPS, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_1FPS, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdTiming, MF_CHECKED);
    
    // Sound
    UpdateSoundStreamerMenu();
    SetSoundMenu();
#ifdef SPEECH_ENABLED
    CheckMenuItem(hMenu, IDM_SPEECH, SpeechDefault ? MF_CHECKED:MF_UNCHECKED);
#endif
    CheckMenuItem(m_hMenu,IDM_SOUNDCHIP,(SoundChipEnabled)?MF_CHECKED:MF_UNCHECKED);
    UpdateSFXMenu();
    CheckMenuItem(m_hMenu,ID_TAPESOUND,(TapeSoundEnabled)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_44100KHZ, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_22050KHZ, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_11025KHZ, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_CHECKED);
    CheckMenuItem(hMenu, IDM_HIGHVOLUME, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_MEDIUMVOLUME, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_LOWVOLUME, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_FULLVOLUME, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdVolume, MF_CHECKED);
    SetPBuff();
    CheckMenuItem(m_hMenu,ID_PSAMPLES,(PartSamples)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_EXPVOLUME, SoundExponentialVolume ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_TEXTTOSPEECH, m_TextToSpeechEnabled ? MF_CHECKED:MF_UNCHECKED);
    
    // AMX
    CheckMenuItem(hMenu, IDM_AMXONOFF, AMXMouseEnabled ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, AMXLRForMiddle ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_320X256, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_640X256, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_160X256, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_CHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTP50, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTP30, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTP10, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTM10, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTM30, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMX_ADJUSTM50, MF_UNCHECKED);
    if (m_MenuIdAMXAdjust != 0)
        CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_CHECKED);
    
    // Hardware -> Model
    UpdateModelType();
    
    // Hardware
    CheckMenuItem(m_hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
#ifdef M512COPRO_ENABLED
    CheckMenuItem(m_hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
#endif
    CheckMenuItem(m_hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
    SetRomMenu();
    CheckMenuItem(hMenu, IDM_SWRAMBOARD, SWRAMBoardEnabled ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS, IgnoreIllegalInstructions ? MF_CHECKED : MF_UNCHECKED);
    UpdateOptiMenu();
    UpdateEconetMenu(hMenu);
    CheckMenuItem(hMenu, ID_TELETEXT, TeleTextAdapterEnabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_FLOPPYDRIVE, Disc8271Enabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_HARDDRIVE, SCSIDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IDEDRIVE, IDEDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_UPRM, RTC_Enabled ? MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_RTCY2KADJUST, RTCY2KAdjust ? MF_CHECKED:MF_UNCHECKED);
    
    // Options
    CheckMenuItem(hMenu, IDM_JOYSTICK, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AMOUSESTICK, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_DMOUSESTICK, MF_UNCHECKED);
    if (m_MenuIdSticks != 0)
        CheckMenuItem(hMenu, m_MenuIdSticks, MF_CHECKED);
    CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, m_FreezeWhenInactive ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_HIDECURSOR, m_HideCursor ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_DEFAULTKYBDMAPPING, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_LOGICALKYBDMAPPING, MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_USERKYBDMAPPING, MF_UNCHECKED);
    CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_CHECKED);
    CheckMenuItem(hMenu, IDM_MAPAS, m_KeyMapAS ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_MAPFUNCS, m_KeyMapFunc ? MF_CHECKED : MF_UNCHECKED);
    UpdateDisableKeysMenu();
    CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_CMOS, m_AutoSavePrefsCMOS ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_FOLDERS, m_AutoSavePrefsFolders ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_ALL, m_AutoSavePrefsAll ? MF_CHECKED : MF_UNCHECKED);
#endif
}

void BeebWin::UpdateDisplayRendererMenu() {
    CheckMenuItem(m_hMenu, IDM_DISPGDI,
                  m_DisplayRenderer == IDM_DISPGDI ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DISPDDRAW,
                  m_DisplayRenderer == IDM_DISPDDRAW ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DISPDX9,
                  m_DisplayRenderer == IDM_DISPDX9 ? MF_CHECKED : MF_UNCHECKED);
}

void BeebWin::UpdateSoundStreamerMenu() {
    CheckMenuItem(m_hMenu, IDM_XAUDIO2, SoundConfig::Selection == SoundConfig::XAudio2 ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DIRECTSOUND, SoundConfig::Selection == SoundConfig::DirectSound ? MF_CHECKED : MF_UNCHECKED);
    if( SoundConfig::Selection == SoundConfig::XAudio2 )
    {
        UsePrimaryBuffer = 0;
        SetPBuff();
    }
    EnableMenuItem(m_hMenu, ID_PBUFF, SoundConfig::Selection == SoundConfig::DirectSound ? MF_ENABLED : MF_GRAYED);
}

void BeebWin::UpdateMonitorMenu() {
    HMENU hMenu = m_hMenu;
    CheckMenuItem(hMenu, ID_MONITOR_RGB, (palette_type == RGB) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MONITOR_BW , (palette_type == BW) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MONITOR_GREEN , (palette_type == GREEN) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MONITOR_AMBER , (palette_type == AMBER) ? MF_CHECKED : MF_UNCHECKED);
}

void BeebWin::UpdateModelType() {
    HMENU hMenu= m_hMenu;
    CheckMenuItem(hMenu, ID_MODELB, (MachineType == 0) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MODELBINT, (MachineType == 1) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MODELBP, (MachineType == 2) ? MF_CHECKED : MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_MASTER128, (MachineType == 3) ? MF_CHECKED : MF_UNCHECKED);
}

void BeebWin::UpdateSFXMenu() {
    HMENU hMenu = m_hMenu;
    CheckMenuItem(hMenu,ID_SFX_RELAY,RelaySoundEnabled?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu,ID_SFX_DISCDRIVES,DiscDriveSoundEnabled?MF_CHECKED:MF_UNCHECKED);
}

void BeebWin::UpdateDisableKeysMenu() {
    CheckMenuItem(m_hMenu, IDM_DISABLEKEYSWINDOWS, m_DisableKeysWindows?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DISABLEKEYSBREAK, m_DisableKeysBreak?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DISABLEKEYSESCAPE, m_DisableKeysEscape?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(m_hMenu, IDM_DISABLEKEYSSHORTCUT, m_DisableKeysShortcut?MF_CHECKED:MF_UNCHECKED);
}

/****************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd,		   // window handle
                         UINT message,	   // type of message
                         WPARAM uParam,	   // additional information
                         LPARAM lParam)	   // additional information
{
    int wmId, wmEvent;
    HDC hdc;
    int row, col;
    
    switch (message)
    {
        case WM_COMMAND:  // message: command from application menu
            wmId	= LOWORD(uParam);
            wmEvent = HIWORD(uParam);
            if (mainWin)
                mainWin->HandleCommand(wmId);
            break;
            
        case WM_PALETTECHANGED:
            if(!mainWin)
                break;
            if ((HWND)uParam == hWnd)
                break;
            
            // fall through to WM_QUERYNEWPALETTE
        case WM_QUERYNEWPALETTE:
            if(!mainWin)
                break;
            
            hdc = GetDC(hWnd);
            mainWin->RealizePalette(hdc);
            ReleaseDC(hWnd,hdc);
            return TRUE;
            break;
            
        case WM_PAINT:
            if(mainWin != NULL)
            {
                PAINTSTRUCT ps;
                HDC 		hDC;
                
                hDC = BeginPaint(hWnd, &ps);
                mainWin->RealizePalette(hDC);
                mainWin->updateLines(hDC, 0, 0);
                EndPaint(hWnd, &ps);
                
                if (mainWin->m_DXResetPending)
                    mainWin->ResetDX();
            }
            break;
            
        case WM_SIZE:
            mainWin->WinSizeChange(uParam, LOWORD(lParam), HIWORD(lParam));
            break;
            
        case WM_MOVE:
            mainWin->WinPosChange(LOWORD(lParam), HIWORD(lParam));
            break;
            
        case WM_SYSKEYDOWN:
            //{char txt[100];sprintf(txt,"SysKeyD: %d, 0x%X, 0x%X\n", uParam, uParam, lParam);OutputDebugString(txt);}
            if (mainWin->m_TextToSpeechEnabled &&
                ((uParam >= VK_NUMPAD0 && uParam <= VK_NUMPAD9) ||
                 uParam == VK_DECIMAL ||
                 uParam == VK_HOME || uParam == VK_END ||
                 uParam == VK_PRIOR || uParam == VK_NEXT ||
                 uParam == VK_UP || uParam == VK_DOWN ||
                 uParam == VK_LEFT || uParam == VK_RIGHT ||
                 uParam == VK_INSERT || uParam == VK_DELETE ||
                 uParam == VK_CLEAR))
            {
                mainWin->TextToSpeechKey(uParam);
            }
            else if (uParam == VK_OEM_8 /* Alt ` */)
            {
                mainWin->TextViewSyncWithBeebCursor();
            }
            else if (uParam == VK_RETURN && (lParam & 0x20000000))
            {
                mainWin->HandleCommand(IDM_FULLSCREEN);
                break;
            }
            else if (uParam == VK_F4 && (lParam & 0x20000000))
            {
                mainWin->HandleCommand(IDM_EXIT);
                break;
            }
            
            if (uParam != VK_F10 && uParam != VK_CONTROL)
                break;
        case WM_KEYDOWN:
            //{char txt[100];sprintf(txt,"KeyD: %d, 0x%X, 0x%X\n", uParam, uParam, lParam);OutputDebugString(txt);}
            if (mainWin->m_TextToSpeechEnabled &&
                ((uParam >= VK_NUMPAD0 && uParam <= VK_NUMPAD9) ||
                 uParam == VK_DECIMAL ||
                 uParam == VK_HOME || uParam == VK_END ||
                 uParam == VK_PRIOR || uParam == VK_NEXT ||
                 uParam == VK_UP || uParam == VK_DOWN ||
                 uParam == VK_LEFT || uParam == VK_RIGHT ||
                 uParam == VK_INSERT || uParam == VK_DELETE ||
                 uParam == VK_CLEAR))
            {
                mainWin->TextToSpeechKey(uParam);
            }
            else if ((uParam == VK_DIVIDE || uParam == VK_MULTIPLY ||
                      uParam == VK_ADD || uParam == VK_SUBTRACT) &&
                     !mainWin->m_DisableKeysShortcut)
            {
                // Ignore shortcut key, handled on key up
            }
            else
            {
                int i;
                int mask;
                bool bit;
                
                mask = 0x01;
                bit = false;
                
                if (mBreakOutWindow == true)
                {
                    for (i = 0; i < 8; ++i)
                    {
                        if (BitKeys[i] == uParam)
                        {
                            if ((UserVIAState.ddrb & mask) == 0x00)
                            {
                                UserVIAState.irb &= ~mask;
                                ShowInputs( (UserVIAState.orb & UserVIAState.ddrb) | (UserVIAState.irb & (~UserVIAState.ddrb)) );
                                bit = true;
                            }
                        }
                        mask <<= 1;
                    }
                }
                if (bit == false)
                {
                    // Reset shift state if it was set by Run Disc
                    if (mainWin->m_ShiftBooted)
                    {
                        mainWin->m_ShiftBooted = false;
                        BeebKeyUp(0, 0);
                    }
                    
                    mainWin->TranslateKey((int)uParam, false, row, col);
                }
            }
            break;
            
        case WM_SYSKEYUP:
            //{char txt[100];sprintf(txt,"SysKeyU: %d, 0x%X, 0x%X\n", uParam, uParam, lParam);OutputDebugString(txt);}
            if ((uParam == 0x35 || uParam == VK_NUMPAD5) && (lParam & 0x20000000))
            {
                mainWin->CaptureBitmapPending(true);
                break;
            }
            
            if (uParam == 0x31 && (lParam & 0x20000000) && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->QuickSave();
                // Let user know state has been saved
                FlashWindow(GETHWND, TRUE);
                MessageBeep(MB_ICONEXCLAMATION);
                break;
            }
            if (uParam == 0x32 && (lParam & 0x20000000) && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->QuickLoad();
                // Let user know state has been loaded
                FlashWindow(GETHWND, TRUE);
                MessageBeep(MB_ICONEXCLAMATION);
                break;
            }
            
            if (uParam == VK_OEM_PLUS && (lParam & 0x20000000))
            {
                mainWin->AdjustSpeed(true);
                break;
            }
            if (uParam == VK_OEM_MINUS && (lParam & 0x20000000))
            {
                mainWin->AdjustSpeed(false);
                break;
            }
            
            if (uParam != VK_F10 && uParam != VK_CONTROL)
                break;
        case WM_KEYUP:
            //{char txt[100];sprintf(txt,"KeyU: %d, 0x%X, 0x%X\n", uParam, uParam, lParam);OutputDebugString(txt);}
            if (uParam == VK_DIVIDE && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->QuickSave();
                // Let user know state has been saved
                FlashWindow(GETHWND, TRUE);
                MessageBeep(MB_ICONEXCLAMATION);
            }
            else if (uParam == VK_MULTIPLY && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->QuickLoad();
                // Let user know state has been loaded
                FlashWindow(GETHWND, TRUE);
                MessageBeep(MB_ICONEXCLAMATION);
            }
            else if (uParam == VK_ADD && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->AdjustSpeed(true);
            }
            else if (uParam == VK_SUBTRACT && !mainWin->m_DisableKeysShortcut)
            {
                mainWin->AdjustSpeed(false);
            }
            else
            {
                int i;
                int mask;
                bool bit;
                
                mask = 0x01;
                bit = false;
                
                if (mBreakOutWindow == true)
                {
                    for (i = 0; i < 8; ++i)
                    {
                        if (BitKeys[i] == uParam)
                        {
                            if ((UserVIAState.ddrb & mask) == 0x00)
                            {
                                UserVIAState.irb |= mask;
                                ShowInputs( (UserVIAState.orb & UserVIAState.ddrb) | (UserVIAState.irb & (~UserVIAState.ddrb)) );
                                bit = true;
                            }
                        }
                        mask <<= 1;
                    }
                }
                
                if (bit == false)
                {
                    if(mainWin->TranslateKey((int)uParam, true, row, col) < 0)
                    {
                        if(row==-2)
                        { // Must do a reset!
                            Init6502core();
                            if (EnableTube) Init65C02core();
#ifdef M512COPRO_ENABLED
                            if (Tube186Enabled) i86_main();
#endif
                            Enable_Z80 = 0;
                            if (TorchTube || AcornZ80)
                            {
                                R1Status = 0;
                                ResetTube();
                                init_z80();
                                Enable_Z80 = 1;
                            }
                            Enable_Arm = 0;
                            if (ArmTube)
                            {
                                R1Status = 0;
                                ResetTube();
                                if (arm) delete arm;
                                arm = new CArm;
                                Enable_Arm = 1;
                            }
                            Disc8271_reset();
                            Reset1770();
                            if (EconetEnabled) EconetReset();//Rob
                            if (SCSIDriveEnabled) SCSIReset();
                            if (SCSIDriveEnabled) SASIReset();
                            if (IDEDriveEnabled)  IDEReset();
                            TeleTextInit();
                            //SoundChipReset();
                        }
                        else if(row==-3)
                        {
                            if (col==-3) SoundTuning+=0.1; // Page Up
                            if (col==-4) SoundTuning-=0.1; // Page Down
                        }
                    }
                }
            }
            break;					  
            
        case WM_ACTIVATE:
            if (mainWin)
            {
                mainWin->Activate(uParam != WA_INACTIVE);
                if(uParam != WA_INACTIVE)
                {
                    // Bring debug window to foreground BEHIND main window.
                    if(hwndDebug)
                    {
                        SetWindowPos(hwndDebug, GETHWND,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW | SWP_NOACTIVATE);
                        SetWindowPos(GETHWND, HWND_TOP,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
                    }
                }
            }
            break;
            
        case WM_SETFOCUS:
            if (mainWin)
                mainWin->Focus(TRUE);
            break;
            
        case WM_KILLFOCUS:
            BeebReleaseAllKeys();
            if (mainWin)
                mainWin->Focus(FALSE);
            break;					  
            
        case MM_JOY1MOVE:
            if (mainWin)
                mainWin->ScaleJoystick(LOWORD(lParam), HIWORD(lParam));
            break;
            
        case MM_JOY1BUTTONDOWN:
        case MM_JOY1BUTTONUP:
            JoystickButton = ((UINT)uParam & (JOY_BUTTON1 | JOY_BUTTON2)) ? 1 : 0;
            break; 
            
        case WM_MOUSEMOVE:
            if (mainWin)
            {
                mainWin->ScaleMousestick(LOWORD(lParam), HIWORD(lParam));
                mainWin->SetAMXPosition(LOWORD(lParam), HIWORD(lParam));
                // Experiment: show menu in full screen when cursor moved to top of window
                if (HideMenuEnabled)
                {
                    if (HIWORD(lParam) <= 2)
                        mainWin->ShowMenu(true);
                    else
                        mainWin->ShowMenu(false);
                }
            }
            break;
            
        case WM_LBUTTONDOWN:
            if (mainWin)
                mainWin->SetMousestickButton(((UINT)uParam & MK_LBUTTON) ? TRUE : FALSE);
            AMXButtons |= AMX_LEFT_BUTTON;
            break;
        case WM_LBUTTONUP:
            if (mainWin)
                mainWin->SetMousestickButton(((UINT)uParam & MK_LBUTTON) ? TRUE : FALSE);
            AMXButtons &= ~AMX_LEFT_BUTTON;
            break;
            
        case WM_MBUTTONDOWN:
            AMXButtons |= AMX_MIDDLE_BUTTON;
            break;
        case WM_MBUTTONUP:
            AMXButtons &= ~AMX_MIDDLE_BUTTON;
            break;
            
        case WM_RBUTTONDOWN:
            AMXButtons |= AMX_RIGHT_BUTTON;
            break;
        case WM_RBUTTONUP:
            AMXButtons &= ~AMX_RIGHT_BUTTON;
            break;
            
        case WM_DESTROY:  // message: window being destroyed
            if (mainWin)
                mainWin->Shutdown();
            PostQuitMessage(0);
            break;
            
        case WM_ENTERMENULOOP: // entering menu, must mute directsound
            SetSound(MUTED);
            break;
            
        case WM_EXITMENULOOP:
            SetSound(UNMUTED);
            if (mainWin)
                mainWin->ResetTiming();
            break;
            
        case WM_ENTERSIZEMOVE: // Window being moved
            SetSound(MUTED);
            break;
        case WM_EXITSIZEMOVE:
            SetSound(UNMUTED);
            break;
            
        case WM_REINITDX:
            mainWin->ReinitDX();
            break;
            
        case WM_TIMER:
            if(uParam == 1)
                mainWin->HandleTimer();
            break;
            
        default:		  // Passes it on if unproccessed
            return (DefWindowProc(hWnd, message, uParam, lParam));
    }
    return (0);
}

/****************************************************************************/
void BeebWin::SetWindowAttributes(bool wasFullScreen)
{
    RECT wndrect;
    long style;
    
    if (m_isFullScreen)
    {
        if (!wasFullScreen)
        {
            GetWindowRect(m_hWnd, &wndrect);
            m_XWinPos = wndrect.left;
            m_YWinPos = wndrect.top;
        }
        
        if (m_DisplayRenderer != IDM_DISPGDI)
        {
            m_XWinSize = m_XDXSize;
            m_YWinSize = m_YDXSize;
            CalcAspectRatioAdjustment(m_XScrSize, m_YScrSize);
            
            style = GetWindowLong(m_hWnd, GWL_STYLE);
            style &= ~(WIN_STYLE);
            style |= WS_POPUP;
            SetWindowLong(m_hWnd, GWL_STYLE, style);
            
            if (m_DXInit == TRUE)
            {
                ResetDX();
            }
        }
        else
        {
            CalcAspectRatioAdjustment(m_XWinSize, m_YWinSize);
            
            style = GetWindowLong(m_hWnd, GWL_STYLE);
            style &= ~WS_POPUP;
            style |= WIN_STYLE;
            SetWindowLong(m_hWnd, GWL_STYLE, style);
            
            ShowWindow(m_hWnd, SW_MAXIMIZE);
        }
        
        // Experiment: hide menu in full screen
        if (HideMenuEnabled)
            ShowMenu(false);
    }
    else
    {
        CalcAspectRatioAdjustment(0, 0);
        
        if (wasFullScreen)
            ShowWindow(m_hWnd, SW_RESTORE);
        
        // Note: Window size gets lost in DDraw mode when DD is reset
        int xs = m_XLastWinSize;
        int ys = m_YLastWinSize;
        
        if (m_DisplayRenderer != IDM_DISPGDI && m_DXInit == TRUE)
        {
            ResetDX();
        }
        
        m_XWinSize = xs;
        m_YWinSize = ys;
        
        style = GetWindowLong(m_hWnd, GWL_STYLE);
        style &= ~WS_POPUP;
        style |= WIN_STYLE;
        SetWindowLong(m_hWnd, GWL_STYLE, style);
        
        SetWindowPos(m_hWnd, HWND_TOP, m_XWinPos, m_YWinPos,
                     m_XWinSize + m_XWinBorder,
                     m_YWinSize + m_YWinBorder,
                     !wasFullScreen ? SWP_NOMOVE : 0);
        
        // Experiment: hide menu in full screen
        if (HideMenuEnabled)
            ShowMenu(true);
    }
    
    // Clear unused areas of screen
    RECT rc;
    GetClientRect(m_hWnd, &rc);
    InvalidateRect(m_hWnd, &rc, TRUE);
}

/*****************************************************************************/
void BeebWin::WinSizeChange(int size, int width, int height)
{
    if (m_DisplayRenderer == IDM_DISPGDI && size == SIZE_RESTORED && m_isFullScreen)
    {
        m_isFullScreen = false;
        CheckMenuItem(m_hMenu, IDM_FULLSCREEN, MF_UNCHECKED);
    }
    
    if (!m_isFullScreen || m_DisplayRenderer == IDM_DISPGDI)
    {
        m_XWinSize = width;
        m_YWinSize = height;
        CalcAspectRatioAdjustment(m_XWinSize, m_YWinSize);
        
        if (size != SIZE_MINIMIZED && m_DisplayRenderer != IDM_DISPGDI && m_DXInit == TRUE)
        {
            m_DXResetPending = true;
        }
    }
    
    if (!m_isFullScreen)
    {
        m_XLastWinSize = m_XWinSize;
        m_YLastWinSize = m_YWinSize;
    }
}

/****************************************************************************/
void BeebWin::WinPosChange(int x, int y)
{
#if 0
    char str[200];
    sprintf(str, "WM_MOVE %d, %d (%d, %d)\n", x, y, m_XWinPos, m_YWinPos);
    OutputDebugString(str);
#endif
}

void BeebWin::UpdateSerialMenu(HMENU hMenu)
{
#if 0
    CheckMenuItem(hMenu, ID_SERIAL, (SerialPortEnabled)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_TOUCHSCREEN, (TouchScreenEnabled)?MF_CHECKED:MF_UNCHECKED);
    //	CheckMenuItem(hMenu, ID_IP232, (EthernetPortEnabled)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232LOCALHOST, (IP232localhost)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232CUSTOM, (IP232custom)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232MODE, (IP232mode)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_IP232RAW, (IP232raw)?MF_CHECKED:MF_UNCHECKED);
    
    CheckMenuItem(hMenu, ID_COM1, (SerialPort==1)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM2, (SerialPort==2)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM3, (SerialPort==3)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu, ID_COM4, (SerialPort==4)?MF_CHECKED:MF_UNCHECKED);
#endif
}

void BeebWin::ExternUpdateSerialMenu(void)
{
#if 0
    HMENU hMenu = m_hMenu;
    UpdateSerialMenu(hMenu);
#endif
}


//Rob
void BeebWin::UpdateEconetMenu(HMENU hMenu) {
    CheckMenuItem(hMenu, ID_ECONET, (EconetEnabled)?MF_CHECKED:MF_UNCHECKED);
}

void BeebWin::UpdateLEDMenu(HMENU hMenu) {
    // Update the LED Menu
    CheckMenuItem(hMenu,ID_RED_LEDS,(DiscLedColour>0)?MF_UNCHECKED:MF_CHECKED);
    CheckMenuItem(hMenu,ID_GREEN_LEDS,(DiscLedColour>0)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu,ID_SHOW_KBLEDS,(LEDs.ShowKB)?MF_CHECKED:MF_UNCHECKED);
    CheckMenuItem(hMenu,ID_SHOW_DISCLEDS,(LEDs.ShowDisc)?MF_CHECKED:MF_UNCHECKED);
}

/***************************************************************************/
void BeebWin::HandleCommand(int MenuId)
{
    char TmpPath[256];
    HMENU hMenu = m_hMenu;
    int prev_palette_type = palette_type;
    int binsize = 0;
    
    SetSound(MUTED);
    
    switch (MenuId)
    {
        case IDM_RUNDISC:
            if (ReadDisc(0,hMenu, true))
            {
                m_ShiftBooted = true;
                ResetBeebSystem(MachineType,TubeEnabled,0);
                BeebKeyDown(0, 0); // Shift key
            }
            break;
            
        case IDM_LOADSTATE:
            RestoreState();
            break;
        case IDM_SAVESTATE:
            SaveState();
            break;
            
        case IDM_QUICKLOAD:
            QuickLoad();
            break;
        case IDM_QUICKSAVE:
            QuickSave();
            break;
            
        case IDM_LOADDISC0:
            ReadDisc(0,hMenu, false);
            break;
        case IDM_LOADDISC1:
            ReadDisc(1,hMenu, false);
            break;
            
        case ID_LOADTAPE:
            LoadTape();
            break;
            
        case IDM_NEWDISC0:
            NewDiscImage(0);
            break;
        case IDM_NEWDISC1:
            NewDiscImage(1);
            break;
            
        case IDM_EJECTDISC0:
            EjectDiscImage(0);
            break;
        case IDM_EJECTDISC1:
            EjectDiscImage(1);
            break;
            
        case IDM_WPDISC0:
            ToggleWriteProtect(0);
            break;
        case IDM_WPDISC1:
            ToggleWriteProtect(1);
            break;
        case IDM_WPONLOAD:
            m_WriteProtectOnLoad = 1 - m_WriteProtectOnLoad;
            CheckMenuItem(hMenu, IDM_WPONLOAD, m_WriteProtectOnLoad ? MF_CHECKED : MF_UNCHECKED);
            break;
            
        case IDM_EDIT_COPY:
            doCopy();
            break;
        case IDM_EDIT_PASTE:
            doPaste();
            break;
        case IDM_EDIT_CRLF:
            m_translateCRLF = !m_translateCRLF;
            CheckMenuItem(hMenu, IDM_EDIT_CRLF, m_translateCRLF ? MF_CHECKED : MF_UNCHECKED);
            break;
            
        case IDM_DISC_EXPORT_0:
        case IDM_DISC_EXPORT_1:
        case IDM_DISC_EXPORT_2:
        case IDM_DISC_EXPORT_3:
            ExportDiscFiles(MenuId);
            break;
            
        case IDM_DISC_IMPORT_0:
        case IDM_DISC_IMPORT_1:
        case IDM_DISC_IMPORT_2:
        case IDM_DISC_IMPORT_3:
            ImportDiscFiles(MenuId);
            break;
            
        case IDM_PRINTER_FILE:
            if (PrinterFile())
            {
                /* If printer is enabled then need to
                 disable it before changing file */
                if (PrinterEnabled)
                    TogglePrinter();
                
                /* Add file name to menu */
                char menu_string[256];
                strcpy(menu_string, "File: ");
                strcat(menu_string, m_PrinterFileName);
                ModifyMenu(hMenu, IDM_PRINTER_FILE,
                           MF_BYCOMMAND, IDM_PRINTER_FILE,
                           menu_string);
                
                if (MenuId != m_MenuIdPrinterPort)
                {
                    CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_UNCHECKED);
                    m_MenuIdPrinterPort = MenuId;
                    CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
                }
                TranslatePrinterPort();
            }
            break;
        case IDM_PRINTER_CLIPBOARD:
            if (PrinterEnabled)
                TogglePrinter();
            
            if (MenuId != m_MenuIdPrinterPort)
            {
                CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_UNCHECKED);
                m_MenuIdPrinterPort = MenuId;
                CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
            }
            TranslatePrinterPort();
            break;
        case IDM_PRINTER_LPT1:
        case IDM_PRINTER_LPT2:
        case IDM_PRINTER_LPT3:
        case IDM_PRINTER_LPT4:
            if (MenuId != m_MenuIdPrinterPort)
            {
                /* If printer is enabled then need to
                 disable it before changing file */
                if (PrinterEnabled)
                    TogglePrinter();
                
                CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_UNCHECKED);
                m_MenuIdPrinterPort = MenuId;
                CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
                TranslatePrinterPort();
            }
            break;
        case IDM_PRINTERONOFF:
            TogglePrinter();
            break;
            
        case ID_SERIAL:
            
            if (SerialPortEnabled) { // so disabling..
                if (TouchScreenEnabled)
                {
                    TouchScreenClose();
                    TouchScreenEnabled = false;
                }
                if (EthernetPortEnabled)
                {
                    IP232Close();
                    EthernetPortEnabled = false;
                    //			IP232custom = false;
                    //			IP232localhost = false;
                }
            }
            SerialPortEnabled=1-SerialPortEnabled;
            
            if (SerialPortEnabled && (IP232custom || IP232localhost))
            {
                EthernetPortEnabled = true;
                if (IP232Open() == false)
                {
                    MessageBox(GETHWND,"Could not connect to specified address",WindowTitle,MB_OK|MB_ICONERROR);
                    bSerialStateChanged=TRUE;
                    UpdateSerialMenu(hMenu);
                    SerialPortEnabled=FALSE;
                }
            }
            bSerialStateChanged=TRUE;
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_TOUCHSCREEN:
            
            if (TouchScreenEnabled)
            {
                TouchScreenClose();
            }
            
            TouchScreenEnabled = 1 - TouchScreenEnabled;
            
            if (TouchScreenEnabled)
            {
                // Also switch on analogue mousestick (touch screen uses
                // mousestick position)
                if (m_MenuIdSticks != IDM_AMOUSESTICK)
                    HandleCommand(IDM_AMOUSESTICK);
                
                if (EthernetPortEnabled)
                {
                    IP232Close();
                    EthernetPortEnabled = false;
                }
                IP232custom = false;
                IP232localhost = false;
                
                SerialPortEnabled = true;
                
                Kill_Serial();
                SerialPort = 0;
                
                bSerialStateChanged=TRUE;
                TouchScreenOpen();
            }
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_IP232MODE:
            IP232mode = 1 - IP232mode;
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_IP232RAW:
            IP232raw = 1 - IP232raw;
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_IP232LOCALHOST:
            
            if (IP232localhost)
            {
                IP232Close();
            }
            
            IP232localhost = 1 - IP232localhost;
            
            if (IP232localhost)
            {
                if (TouchScreenEnabled)
                {
                    TouchScreenClose();
                }
                if (IP232custom) IP232Close();
                IP232custom = false;
                EthernetPortEnabled = true;
                TouchScreenEnabled = false;
                
                Kill_Serial();
                
                SerialPort = 0;
                bSerialStateChanged=TRUE;
                
                strcpy(IPAddress,"127.0.0.1");
                PortNo = 25232;
                
                if (SerialPortEnabled) {
                    if (IP232Open() == false)
                    {
                        MessageBox(GETHWND,"Could not connect to specified address",WindowTitle,MB_OK|MB_ICONERROR);
                        bSerialStateChanged=TRUE;
                        UpdateSerialMenu(hMenu);
                        SerialPortEnabled=FALSE;
                    }
                }
            }
            
            if (IP232localhost == 0 &&  IP232custom == 0)
            {
                EthernetPortEnabled = false;
                IP232Close();
            }
            
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_IP232CUSTOM:
            
            if (IP232custom)
            {
                IP232Close();
            }
            
            IP232custom = 1 - IP232custom;
            
            if (IP232custom)
            {
                if (TouchScreenEnabled)
                {
                    TouchScreenClose();
                }
                if (IP232localhost) IP232Close();
                IP232localhost = false;
                EthernetPortEnabled = true;
                TouchScreenEnabled = false;
                
                Kill_Serial();
                
                SerialPort = 0;
                bSerialStateChanged=TRUE;
                
                strcpy(IPAddress,IP232customip);
                PortNo = IP232customport;
                if (SerialPortEnabled) {
                    if (IP232Open() == false)
                    {
                        MessageBox(GETHWND,"Could not connect to specified address",WindowTitle,MB_OK|MB_ICONERROR);
                        bSerialStateChanged=TRUE;
                        UpdateSerialMenu(hMenu);
                        SerialPortEnabled=FALSE;
                    }
                }
            }
            
            if (IP232localhost == 0 && IP232custom == 0)
            {
                EthernetPortEnabled = false;
                IP232Close();
            }
            
            UpdateSerialMenu(hMenu);
            break;
            
        case ID_COM1:
            SerialPort=1; bSerialStateChanged=TRUE; EthernetPortEnabled = false; IP232custom = false; IP232localhost = false; TouchScreenEnabled = false; IP232Close(); TouchScreenClose(); UpdateSerialMenu(hMenu); break;
            
        case ID_COM2:
            SerialPort=2; bSerialStateChanged=TRUE; EthernetPortEnabled = false; IP232custom = false; IP232localhost = false; TouchScreenEnabled = false; IP232Close(); TouchScreenClose(); UpdateSerialMenu(hMenu); break;
            
        case ID_COM3:
            SerialPort=3; bSerialStateChanged=TRUE; EthernetPortEnabled = false; IP232custom = false; IP232localhost = false; TouchScreenEnabled = false; IP232Close(); TouchScreenClose(); UpdateSerialMenu(hMenu); break;
            
        case ID_COM4:
            SerialPort=4; bSerialStateChanged=TRUE; EthernetPortEnabled = false; IP232custom = false; IP232localhost = false; TouchScreenEnabled = false; IP232Close(); TouchScreenClose(); UpdateSerialMenu(hMenu); break;
            
            
            //Rob
        case ID_ECONET:
            EconetEnabled= 1-EconetEnabled;
            if (EconetEnabled)
            {
                // Need hard reset for DNFS to detect econet HW
                ResetBeebSystem(MachineType,TubeEnabled,0);
                EconetStateChanged=TRUE;
            }
            else
            {
                EconetReset();
            }
            UpdateEconetMenu(hMenu);
            break;
            
        case IDM_DISPGDI:
        case IDM_DISPDDRAW:
        case IDM_DISPDX9:
        {
            int enabled;
            ExitDX();
            
            m_DisplayRenderer = MenuId;
            SetWindowAttributes(m_isFullScreen);
            
            if (m_DisplayRenderer != IDM_DISPGDI)
            {
                InitDX();
                enabled = MF_ENABLED;
            }
            else
            {
                enabled = MF_GRAYED;
            }
            UpdateDisplayRendererMenu();
            EnableMenuItem(hMenu, IDM_DXSMOOTHING, enabled);
            EnableMenuItem(hMenu, IDM_DXSMOOTHMODE7ONLY, enabled);
            break;
        }
            
        case IDM_DXSMOOTHING:
            m_DXSmoothing = !m_DXSmoothing;
            CheckMenuItem(hMenu, IDM_DXSMOOTHING, m_DXSmoothing ? MF_CHECKED : MF_UNCHECKED);
            if (m_DisplayRenderer != IDM_DISPGDI)
            {
                UpdateSmoothing();
            }
            break;
            
        case IDM_DXSMOOTHMODE7ONLY:
            m_DXSmoothMode7Only = !m_DXSmoothMode7Only;
            CheckMenuItem(hMenu, IDM_DXSMOOTHMODE7ONLY, m_DXSmoothMode7Only ? MF_CHECKED : MF_UNCHECKED);
            if (m_DisplayRenderer != IDM_DISPGDI)
            {
                UpdateSmoothing();
            }
            break;
            
        case IDM_320X256:
        case IDM_640X512:
        case IDM_800X600:
        case IDM_1024X512:
        case IDM_1024X768:
        case IDM_1280X1024:
        case IDM_1440X1080:
        case IDM_1600X1200:
        {
            if (m_isFullScreen)
                HandleCommand(IDM_FULLSCREEN);
            //CheckMenuItem(hMenu, m_MenuIdWinSize, MF_UNCHECKED);
            m_MenuIdWinSize = MenuId;
            //CheckMenuItem(hMenu, m_MenuIdWinSize, MF_CHECKED);
            TranslateWindowSize();
            SetWindowAttributes(m_isFullScreen);
        }
            break;
            
        case ID_VIEW_DD_640X480:
        case ID_VIEW_DD_720X576:
        case ID_VIEW_DD_800X600:
        case ID_VIEW_DD_1024X768:
        case ID_VIEW_DD_1280X720:
        case ID_VIEW_DD_1280X768:
        case ID_VIEW_DD_1280X960:
        case ID_VIEW_DD_1280X1024:
        case ID_VIEW_DD_1440X900:
        case ID_VIEW_DD_1600X1200:
        case ID_VIEW_DD_1920X1080:
        {
            CheckMenuItem(hMenu, m_DDFullScreenMode, MF_UNCHECKED);
            m_DDFullScreenMode = MenuId;
            CheckMenuItem(hMenu, m_DDFullScreenMode, MF_CHECKED);
            TranslateDDSize();
            
            if (m_isFullScreen && m_DisplayRenderer != IDM_DISPGDI)
            {
                SetWindowAttributes(m_isFullScreen);
            }
        }
            break;
            
        case IDM_FULLSCREEN:
            m_isFullScreen = !m_isFullScreen;
            CheckMenuItem(hMenu, IDM_FULLSCREEN, m_isFullScreen ? MF_CHECKED : MF_UNCHECKED);
            SetWindowAttributes(!m_isFullScreen);
            break;
            
        case IDM_MAINTAINASPECTRATIO:
            m_MaintainAspectRatio = !m_MaintainAspectRatio;
            CheckMenuItem(hMenu, IDM_MAINTAINASPECTRATIO, m_MaintainAspectRatio ? MF_CHECKED : MF_UNCHECKED);
            if (m_isFullScreen)
            {
                // Clear unused areas of screen
                RECT rc;
                GetClientRect(m_hWnd, &rc);
                InvalidateRect(m_hWnd, &rc, TRUE);
            }
            break;
            
        case IDM_SPEEDANDFPS:
            if (m_ShowSpeedAndFPS)
            {
                m_ShowSpeedAndFPS = FALSE;
                CheckMenuItem(hMenu, IDM_SPEEDANDFPS, MF_UNCHECKED);
                SetWindowText(m_hWnd, WindowTitle);
            }
            else
            {
                m_ShowSpeedAndFPS = TRUE;
                CheckMenuItem(hMenu, IDM_SPEEDANDFPS, MF_CHECKED);
            }
            break;
            
        case IDM_XAUDIO2:
        case IDM_DIRECTSOUND:
            SoundConfig::Selection = MenuId == IDM_XAUDIO2 ? SoundConfig::XAudio2 : SoundConfig::DirectSound;
            
            if (SoundEnabled)
            {
                SoundReset();
                SoundInit();
            }
            
#ifdef SPEECH_ENABLED
            if (SpeechDefault)
            {
                tms5220_stop();
                tms5220_start();
            }
#endif
            
            UpdateSoundStreamerMenu();
            break;
            
        case IDM_SOUNDONOFF:
            if (SoundDefault)
            {
                CheckMenuItem(hMenu, IDM_SOUNDONOFF, MF_UNCHECKED);
                SoundReset();
                SoundDefault=0;
            }
            else
            {
                SoundInit();
                if (SoundEnabled) {
                    CheckMenuItem(hMenu, IDM_SOUNDONOFF, MF_CHECKED);
                    SoundDefault=1;
                }
            }
            break;
        case IDM_SOUNDCHIP:
            SoundChipEnabled=1-SoundChipEnabled;
            CheckMenuItem(hMenu, IDM_SOUNDCHIP, SoundChipEnabled?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_SFX_RELAY:
            RelaySoundEnabled=1-RelaySoundEnabled;
            CheckMenuItem(hMenu,ID_SFX_RELAY,RelaySoundEnabled?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_SFX_DISCDRIVES:
            DiscDriveSoundEnabled=1-DiscDriveSoundEnabled;
            CheckMenuItem(hMenu,ID_SFX_DISCDRIVES,DiscDriveSoundEnabled?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case IDM_44100KHZ:
        case IDM_22050KHZ:
        case IDM_11025KHZ:
            if (MenuId != m_MenuIdSampleRate)
            {
                CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_UNCHECKED);
                m_MenuIdSampleRate = MenuId;
                CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_CHECKED);
                TranslateSampleRate();
                
                if (SoundEnabled)
                {
                    SoundReset();
                    SoundInit();
                }
                
#ifdef SPEECH_ENABLED
                if (SpeechDefault)
                {
                    tms5220_stop();
                    tms5220_start();
                }
#endif
            }
            break;
            
        case IDM_FULLVOLUME:
        case IDM_HIGHVOLUME:
        case IDM_MEDIUMVOLUME:
        case IDM_LOWVOLUME:
            if (MenuId != m_MenuIdVolume)
            {
                CheckMenuItem(hMenu, m_MenuIdVolume, MF_UNCHECKED);
                m_MenuIdVolume = MenuId;
                CheckMenuItem(hMenu, m_MenuIdVolume, MF_CHECKED);
                TranslateVolume();
            }
            break;
            
            /* LRW Added switch individual ROMS Writable ON/OFF */
        case IDM_ALLOWWRITES_ROM0:
        case IDM_ALLOWWRITES_ROM1:
        case IDM_ALLOWWRITES_ROM2:
        case IDM_ALLOWWRITES_ROM3:
        case IDM_ALLOWWRITES_ROM4:
        case IDM_ALLOWWRITES_ROM5:
        case IDM_ALLOWWRITES_ROM6:
        case IDM_ALLOWWRITES_ROM7:
        case IDM_ALLOWWRITES_ROM8:
        case IDM_ALLOWWRITES_ROM9:
        case IDM_ALLOWWRITES_ROMA:
        case IDM_ALLOWWRITES_ROMB:
        case IDM_ALLOWWRITES_ROMC:
        case IDM_ALLOWWRITES_ROMD:
        case IDM_ALLOWWRITES_ROME:
        case IDM_ALLOWWRITES_ROMF:
        {
            int slot = MenuId-IDM_ALLOWWRITES_ROM0;
            RomWritable[slot] = 1-RomWritable[slot];
            CheckMenuItem(hMenu, MenuId, RomWritable[slot] ? MF_CHECKED : MF_UNCHECKED);
            break;
        }
            
        case IDM_SWRAMBOARD:
            SWRAMBoardEnabled = 1-SWRAMBoardEnabled;
            CheckMenuItem(hMenu, IDM_SWRAMBOARD, SWRAMBoardEnabled ? MF_CHECKED : MF_UNCHECKED);
            break;
            
        case IDM_ROMCONFIG:
            EditROMConfig();
            SetRomMenu();
            break;
            
        case IDM_REALTIME:
        case IDM_FIXEDSPEED100:
        case IDM_FIXEDSPEED50:
        case IDM_FIXEDSPEED10:
        case IDM_FIXEDSPEED5:
        case IDM_FIXEDSPEED2:
        case IDM_FIXEDSPEED1_5:
        case IDM_FIXEDSPEED1_25:
        case IDM_FIXEDSPEED1_1:
        case IDM_FIXEDSPEED0_9:
        case IDM_FIXEDSPEED0_5:
        case IDM_FIXEDSPEED0_75:
        case IDM_FIXEDSPEED0_25:
        case IDM_FIXEDSPEED0_1:
        case IDM_50FPS:
        case IDM_25FPS:
        case IDM_10FPS:
        case IDM_5FPS:
        case IDM_1FPS:
            if (MenuId != m_MenuIdTiming)
            {
                CheckMenuItem(hMenu, m_MenuIdTiming, MF_UNCHECKED);
                m_MenuIdTiming = MenuId;
                CheckMenuItem(hMenu, m_MenuIdTiming, MF_CHECKED);
                TranslateTiming();
            }
            break;
            
        case IDM_JOYSTICK:
        case IDM_AMOUSESTICK:
        case IDM_DMOUSESTICK:
            /* Disable current selection */
            if (m_MenuIdSticks != 0)
            {
                CheckMenuItem(hMenu, m_MenuIdSticks, MF_UNCHECKED);
                if (m_MenuIdSticks == IDM_JOYSTICK)
                {
                    ResetJoystick();
                }
                else /* mousestick */
                {
                    AtoDDisable();
                }
            }
            
            if (MenuId == m_MenuIdSticks)
            {
                /* Joysticks switched off completely */
                m_MenuIdSticks = 0;
            }
            else
            {
                /* Initialise new selection */
                m_MenuIdSticks = MenuId;
                if (m_MenuIdSticks == IDM_JOYSTICK)
                {
                    InitJoystick();
                }
                else /* mousestick */
                {
                    AtoDEnable();
                }
                if (JoystickEnabled)
                    CheckMenuItem(hMenu, m_MenuIdSticks, MF_CHECKED);
                else
                    m_MenuIdSticks = 0;
            }
            break;
            
        case IDM_FREEZEINACTIVE:
            if (m_FreezeWhenInactive)
            {
                m_FreezeWhenInactive = FALSE;
                CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, MF_UNCHECKED);
            }
            else
            {
                m_FreezeWhenInactive = TRUE;
                CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, MF_CHECKED);
            }
            break;
            
        case IDM_HIDECURSOR:
            if (m_HideCursor)
            {
                m_HideCursor = FALSE;
                CheckMenuItem(hMenu, IDM_HIDECURSOR, MF_UNCHECKED);
            }
            else
            {
                m_HideCursor = TRUE;
                CheckMenuItem(hMenu, IDM_HIDECURSOR, MF_CHECKED);
            }
            break;
            
        case IDM_IGNOREILLEGALOPS:
            if (IgnoreIllegalInstructions)
            {
                IgnoreIllegalInstructions = FALSE;
                CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS, MF_UNCHECKED);
            }
            else
            {
                IgnoreIllegalInstructions = TRUE;
                CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS, MF_CHECKED);
            }
            break;
            
        case IDM_DEFINEKEYMAP:
            UserKeyboardDialog( m_hWnd );
            break;
            
        case IDM_LOADKEYMAP:
            LoadUserKeyMap();
            break;
            
        case IDM_SAVEKEYMAP:
            SaveUserKeyMap();
            break;
            
        case IDM_USERKYBDMAPPING:
        case IDM_DEFAULTKYBDMAPPING:
        case IDM_LOGICALKYBDMAPPING:
            if (MenuId != m_MenuIdKeyMapping)
            {
                CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_UNCHECKED);
                m_MenuIdKeyMapping = MenuId;
                CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_CHECKED);
                TranslateKeyMapping();
            }
            break;
            
        case IDM_MAPAS:
            if (m_KeyMapAS)
            {
                m_KeyMapAS = FALSE;
                CheckMenuItem(hMenu, IDM_MAPAS, MF_UNCHECKED);
            }
            else
            {
                m_KeyMapAS = TRUE;
                CheckMenuItem(hMenu, IDM_MAPAS, MF_CHECKED);
            }
            break;
        case IDM_MAPFUNCS:
            if (m_KeyMapFunc)
            {
                m_KeyMapFunc = FALSE;
                CheckMenuItem(hMenu, IDM_MAPFUNCS, MF_UNCHECKED);
            }
            else
            {
                m_KeyMapFunc = TRUE;
                CheckMenuItem(hMenu, IDM_MAPFUNCS, MF_CHECKED);
            }
            break;
            
        case IDM_ABOUT:
            MessageBox(m_hWnd, AboutText, WindowTitle, MB_OK);
            break;
            
        case IDM_VIEWREADME:
            strcpy(TmpPath, m_AppPath);
            strcat(TmpPath, "Help\\index.html");
            ShellExecute(m_hWnd, NULL, TmpPath, NULL, NULL, SW_SHOWNORMAL);;
            break;
            
        case IDM_EXIT:
            PostMessage(m_hWnd, WM_CLOSE, 0, 0L);
            break;
            
        case IDM_SAVE_PREFS:
            SavePreferences(true);
            break;
            
        case IDM_AUTOSAVE_PREFS_CMOS:
            m_AutoSavePrefsCMOS = !m_AutoSavePrefsCMOS;
            CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_CMOS, m_AutoSavePrefsCMOS ? MF_CHECKED : MF_UNCHECKED);
            m_AutoSavePrefsChanged = true;
            break;
        case IDM_AUTOSAVE_PREFS_FOLDERS:
            m_AutoSavePrefsFolders = !m_AutoSavePrefsFolders;
            CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_FOLDERS, m_AutoSavePrefsFolders ? MF_CHECKED : MF_UNCHECKED);
            m_AutoSavePrefsChanged = true;
            break;
        case IDM_AUTOSAVE_PREFS_ALL:
            m_AutoSavePrefsAll = !m_AutoSavePrefsAll;
            CheckMenuItem(hMenu, IDM_AUTOSAVE_PREFS_ALL, m_AutoSavePrefsAll ? MF_CHECKED : MF_UNCHECKED);
            m_AutoSavePrefsChanged = true;
            break;
        case IDM_SELECT_USER_DATA_FOLDER:
            SelectUserDataPath();
            break;
            
        case IDM_AMXONOFF:
            if (AMXMouseEnabled)
            {
                CheckMenuItem(hMenu, IDM_AMXONOFF, MF_UNCHECKED);
                AMXMouseEnabled = FALSE;
            }
            else
            {
                CheckMenuItem(hMenu, IDM_AMXONOFF, MF_CHECKED);
                AMXMouseEnabled = TRUE;
            }
            break;
            
        case IDM_AMX_LRFORMIDDLE:
            if (AMXLRForMiddle)
            {
                CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, MF_UNCHECKED);
                AMXLRForMiddle = FALSE;
            }
            else
            {
                CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, MF_CHECKED);
                AMXLRForMiddle = TRUE;
            }
            break;
            
        case IDM_AMX_160X256:
        case IDM_AMX_320X256:
        case IDM_AMX_640X256:
            if (MenuId != m_MenuIdAMXSize)
            {
                CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_UNCHECKED);
                m_MenuIdAMXSize = MenuId;
                CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_CHECKED);
            }
            TranslateAMX();
            break;
            
        case IDM_AMX_ADJUSTP50:
        case IDM_AMX_ADJUSTP30:
        case IDM_AMX_ADJUSTP10:
        case IDM_AMX_ADJUSTM10:
        case IDM_AMX_ADJUSTM30:
        case IDM_AMX_ADJUSTM50:
            if (m_MenuIdAMXAdjust != 0)
            {
                CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_UNCHECKED);
            }
            
            if (MenuId != m_MenuIdAMXAdjust)
            {
                m_MenuIdAMXAdjust = MenuId;
                CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_CHECKED);
            }
            else
            {
                m_MenuIdAMXAdjust = 0;
            }
            TranslateAMX();
            break;
            
        case ID_MONITOR_RGB:
            palette_type = RGB;
            CreateBitmap();
            break;
        case ID_MONITOR_BW:
            palette_type = BW;
            CreateBitmap();
            break;
        case ID_MONITOR_GREEN:
            palette_type = GREEN;
            CreateBitmap();
            break;
        case ID_MONITOR_AMBER:
            palette_type = AMBER;
            CreateBitmap();
            break;
            
        case IDM_ARM:
            ArmTube=1-ArmTube;
            TubeEnabled = 0;
#ifdef M512COPRO_ENABLED
            Tube186Enabled = 0;
#endif
            TorchTube = 0;
            AcornZ80 = 0;
            CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
#ifdef M512COPRO_ENABLED
            CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
#endif
            CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
            
        case IDM_TUBE:
            TubeEnabled=1-TubeEnabled;
#ifdef M512COPRO_ENABLED
            Tube186Enabled = 0;
#endif
            TorchTube = 0;
            ArmTube = 0;
            AcornZ80 = 0;
            CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
#ifdef M512COPRO_ENABLED
            CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
#endif
            CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
            
#ifdef M512COPRO_ENABLED
        case IDM_TUBE186:
            Tube186Enabled=1-Tube186Enabled;
            TubeEnabled = 0;
            TorchTube = 0;
            AcornZ80 = 0;
            ArmTube = 0;
            CheckMenuItem(hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
#endif
            
        case IDM_TORCH:
            TorchTube=1-TorchTube;
            TubeEnabled=0;
#ifdef M512COPRO_ENABLED
            Tube186Enabled=0;
#endif
            AcornZ80 = 0;
            ArmTube = 0;
            CheckMenuItem(hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
#ifdef M512COPRO_ENABLED
            CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
#endif
            CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
            
        case IDM_ACORNZ80:
            AcornZ80=1-AcornZ80;
            TubeEnabled=0;
            TorchTube=0;
#ifdef M512COPRO_ENABLED
            Tube186Enabled=0;
#endif
            ArmTube = 0;
            CheckMenuItem(hMenu, IDM_ARM, (ArmTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
#ifdef M512COPRO_ENABLED
            CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
#endif
            CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
            CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
            
        case ID_FILE_RESET:
            ResetBeebSystem(MachineType,TubeEnabled,0);
            break;
            
        case ID_MODELB:
            if (MachineType!=0)
            {
                ResetBeebSystem(0,EnableTube,1);
                UpdateModelType();
            }
            break;
        case ID_MODELBINT:
            if (MachineType!=1)
            {
                ResetBeebSystem(1,EnableTube,1);
                UpdateModelType();
            }
            break;
        case ID_MODELBP:
            if (MachineType!=2)
            {
                ResetBeebSystem(2,EnableTube,1);
                UpdateModelType();
            }
            break;
        case ID_MASTER128:
            if (MachineType!=3)
            {
                ResetBeebSystem(3,EnableTube,1);
                UpdateModelType();
            }
            break;
            
        case ID_REWINDTAPE:
            RewindTape();
            break;
        case ID_UNLOCKTAPE:
            UnlockTape=1-UnlockTape;
            SetUnlockTape(UnlockTape);
            CheckMenuItem(hMenu, ID_UNLOCKTAPE, (UnlockTape)?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_HIDEMENU:
            HideMenuEnabled=1-HideMenuEnabled;
            CheckMenuItem(hMenu, ID_HIDEMENU, (HideMenuEnabled)?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_RED_LEDS:
            DiscLedColour=0;
            UpdateLEDMenu(hMenu);
            break;
        case ID_GREEN_LEDS:
            DiscLedColour=1;
            UpdateLEDMenu(hMenu);
            break;
        case ID_SHOW_KBLEDS:
            LEDs.ShowKB=!LEDs.ShowKB;
            UpdateLEDMenu(hMenu);
            break;
        case ID_SHOW_DISCLEDS:
            LEDs.ShowDisc=!LEDs.ShowDisc;
            UpdateLEDMenu(hMenu);
            break;
            
        case ID_FDC_DLL:
            if (MachineType != 3)
                SelectFDC();
            break;
        case ID_8271:
            KillDLLs();
            NativeFDC=TRUE;
            CheckMenuItem(m_hMenu,ID_8271,MF_CHECKED);
            CheckMenuItem(m_hMenu,ID_FDC_DLL,MF_UNCHECKED);
            if (MachineType != 3)
            {
                char CfgName[20];
                sprintf(CfgName, "FDCDLL%d", MachineType);
                PrefsSetStringValue(CfgName,"None");
            }
            break;
            
        case ID_TAPE_FAST:
            SetTapeSpeed(750);
            SetTapeSpeedMenu();
            break;
        case ID_TAPE_MFAST:
            SetTapeSpeed(1600);
            SetTapeSpeedMenu();
            break;
        case ID_TAPE_MSLOW:
            SetTapeSpeed(3200);
            SetTapeSpeedMenu();
            break;
        case ID_TAPE_NORMAL:
            SetTapeSpeed(5600);
            SetTapeSpeedMenu();
            break;
        case ID_TAPESOUND:
            TapeSoundEnabled=!TapeSoundEnabled;
            CheckMenuItem(m_hMenu,ID_TAPESOUND,(TapeSoundEnabled)?MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_TAPECONTROL:
            if (TapeControlEnabled)
                TapeControlCloseDialog();
            else
                TapeControlOpenDialog(hInst, m_hWnd);
            break;
            
        case ID_BREAKOUT:
            if (mBreakOutWindow)
                BreakOutCloseDialog();
            else
                BreakOutOpenDialog(hInst, m_hWnd);
            break;
            
        case ID_UPRM:
            RTC_Enabled = 1 - RTC_Enabled;
            CheckMenuItem(m_hMenu, ID_UPRM, RTC_Enabled ? MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_PBUFF:
            UsePrimaryBuffer=1-UsePrimaryBuffer;
            SetPBuff();
            SoundReset();
            if (SoundDefault) SoundInit();
            break;
        case ID_TSTYLE:
            THalfMode=1-THalfMode;
            UpdateOptiMenu();
            break;
            
        case ID_DOCONLY:
            OpCodes=1;
            UpdateOptiMenu();
            break;
        case ID_EXTRAS:
            OpCodes=2;
            UpdateOptiMenu();
            break;
        case ID_FULLSET:
            OpCodes=3;
            UpdateOptiMenu();
            break;
        case ID_BHARDWARE:
            BHardware=1-BHardware;
            UpdateOptiMenu();
            break;
        case ID_PSAMPLES:
            PartSamples=1-PartSamples;
            UpdateOptiMenu();
            break;
        case IDM_EXPVOLUME:
            SoundExponentialVolume=1-SoundExponentialVolume;
            CheckMenuItem(m_hMenu, IDM_EXPVOLUME, SoundExponentialVolume ? MF_CHECKED:MF_UNCHECKED);
            break;
            
        case IDM_SHOWDEBUGGER:
            if (DebugEnabled)
                DebugCloseDialog();
            else
                DebugOpenDialog(hInst, m_hWnd);
            break;
            
        case IDM_BLUR_OFF:
        case IDM_BLUR_2:
        case IDM_BLUR_4:
        case IDM_BLUR_8:
            if (MenuId != m_MotionBlur)
            {
                CheckMenuItem(hMenu, m_MotionBlur, MF_UNCHECKED);
                m_MotionBlur = MenuId;
                CheckMenuItem(hMenu, m_MotionBlur, MF_CHECKED);
            }
            break;
            
        case IDM_CAPTURERES1:
        case IDM_CAPTURERES2:
        case IDM_CAPTURERES3:
            if (MenuId != m_MenuIdCaptureResolution)
            {
                CheckMenuItem(hMenu, m_MenuIdCaptureResolution, MF_UNCHECKED);
                m_MenuIdCaptureResolution = MenuId;
                CheckMenuItem(hMenu, m_MenuIdCaptureResolution, MF_CHECKED);
            }
            break;
        case IDM_CAPTUREBMP:
        case IDM_CAPTUREJPEG:
        case IDM_CAPTUREGIF:
        case IDM_CAPTUREPNG:
            if (MenuId != m_MenuIdCaptureFormat)
            {
                CheckMenuItem(hMenu, m_MenuIdCaptureFormat, MF_UNCHECKED);
                m_MenuIdCaptureFormat = MenuId;
                CheckMenuItem(hMenu, m_MenuIdCaptureFormat, MF_CHECKED);
            }
            break;
        case IDM_CAPTURESCREEN:
            // Prompt for file name.  Need to do this in WndProc otherwise
            // dialog does not show in full screen mode.
            if (GetImageFile(m_CaptureFileName))
                CaptureBitmapPending(false);
            break;
            
        case IDM_VIDEORES1:
        case IDM_VIDEORES2:
        case IDM_VIDEORES3:
            if (MenuId != m_MenuIdAviResolution)
            {
                CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_UNCHECKED);
                m_MenuIdAviResolution = MenuId;
                CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_CHECKED);
            }
            break;
        case IDM_VIDEOSKIP0:
        case IDM_VIDEOSKIP1:
        case IDM_VIDEOSKIP2:
        case IDM_VIDEOSKIP3:
        case IDM_VIDEOSKIP4:
        case IDM_VIDEOSKIP5:
            if (MenuId != m_MenuIdAviSkip)
            {
                CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_UNCHECKED);
                m_MenuIdAviSkip = MenuId;
                CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_CHECKED);
            }
            break;
        case IDM_CAPTUREVIDEO:
            CaptureVideo();
            break;
        case IDM_ENDVIDEO:
            if (aviWriter != NULL)
            {
                delete aviWriter;
                aviWriter = NULL;
            }
            break;
            
#ifdef SPEECH_ENABLED
        case IDM_SPEECH:
            if (SpeechDefault)
            {
                CheckMenuItem(hMenu, IDM_SPEECH, MF_UNCHECKED);
                tms5220_stop();
                SpeechDefault = 0;
            }
            else
            {
                tms5220_start();
                if (SpeechEnabled)
                {
                    CheckMenuItem(hMenu, IDM_SPEECH, MF_CHECKED);
                    SpeechDefault = 1;
                }
            }
            break;
#endif
            
        case ID_TELETEXT:
            TeleTextAdapterEnabled = 1-TeleTextAdapterEnabled;
            TeleTextInit();
            CheckMenuItem(hMenu, ID_TELETEXT, TeleTextAdapterEnabled ? MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_HARDDRIVE:
            SCSIDriveEnabled = 1-SCSIDriveEnabled;
            SCSIReset();
            SASIReset();
            CheckMenuItem(hMenu, ID_HARDDRIVE, SCSIDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
            if (SCSIDriveEnabled) {
                IDEDriveEnabled=0;
                CheckMenuItem(hMenu, ID_IDEDRIVE, IDEDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
            }
            break;
            
        case ID_IDEDRIVE:
            IDEDriveEnabled = 1-IDEDriveEnabled;
            IDEReset();
            CheckMenuItem(hMenu, ID_IDEDRIVE, IDEDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
            if (IDEDriveEnabled) {
                SCSIDriveEnabled=0;
                CheckMenuItem(hMenu, ID_HARDDRIVE, SCSIDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
            }
            break;
            
        case ID_FLOPPYDRIVE:
            Disc8271Enabled = 1-Disc8271Enabled;
            Disc1770Enabled = 1-Disc1770Enabled;
            CheckMenuItem(hMenu, ID_FLOPPYDRIVE, Disc8271Enabled ? MF_CHECKED:MF_UNCHECKED);
            break;
            
        case ID_RTCY2KADJUST:
            RTCY2KAdjust = 1-RTCY2KAdjust;
            RTCInit();
            CheckMenuItem(hMenu, ID_RTCY2KADJUST, RTCY2KAdjust ? MF_CHECKED:MF_UNCHECKED);
            break;
            
        case IDM_TEXTTOSPEECH:
            m_TextToSpeechEnabled = 1-m_TextToSpeechEnabled;
            InitTextToSpeech();
            break;
            
        case IDM_TEXTVIEW:
            m_TextViewEnabled = 1-m_TextViewEnabled;
            InitTextView();
            break;
            
        case IDM_DISABLEKEYSWINDOWS:
        {
            bool reboot = false;
            m_DisableKeysWindows=1-m_DisableKeysWindows;
            UpdateDisableKeysMenu();
            if (m_DisableKeysWindows)
            {
                // Give user warning
                if (MessageBox(m_hWnd,"Disabling the Windows keys will affect the whole PC.\n"
                               "Go ahead and disable the Windows keys?",
                               WindowTitle,MB_YESNO|MB_ICONQUESTION) == IDYES)
                {
                    int binsize=sizeof(CFG_DISABLE_WINDOWS_KEYS);
                    RegSetBinaryValue(HKEY_LOCAL_MACHINE, CFG_KEYBOARD_LAYOUT,
                                      CFG_SCANCODE_MAP, CFG_DISABLE_WINDOWS_KEYS, &binsize);
                    reboot = true;
                }
                else
                {
                    m_DisableKeysWindows=0;
                    UpdateDisableKeysMenu();
                }
            }
            else
            {
                int binsize=0;
                RegSetBinaryValue(HKEY_LOCAL_MACHINE, CFG_KEYBOARD_LAYOUT,
                                  CFG_SCANCODE_MAP, CFG_DISABLE_WINDOWS_KEYS, &binsize);
                reboot = true;
            }
            
            if (reboot)
            {
                // Ask user for reboot
                if (MessageBox(m_hWnd,"Reboot required for key change to\ntake effect. Reboot now?",
                               WindowTitle,MB_YESNO|MB_ICONQUESTION) == IDYES)
                {
                    RebootSystem();
                }
            }
            break;
        }
        case IDM_DISABLEKEYSBREAK:
            m_DisableKeysBreak=1-m_DisableKeysBreak;
            UpdateDisableKeysMenu();
            break;
        case IDM_DISABLEKEYSESCAPE:
            m_DisableKeysEscape=1-m_DisableKeysEscape;
            UpdateDisableKeysMenu();
            break;
        case IDM_DISABLEKEYSSHORTCUT:
            m_DisableKeysShortcut=1-m_DisableKeysShortcut;
            UpdateDisableKeysMenu();
            break;
        case IDM_DISABLEKEYSALL:
            if (m_DisableKeysWindows && m_DisableKeysBreak &&
                m_DisableKeysEscape && m_DisableKeysShortcut)
            {
                if (m_DisableKeysWindows)
                    HandleCommand(IDM_DISABLEKEYSWINDOWS);
                m_DisableKeysBreak=0;
                m_DisableKeysEscape=0;
                m_DisableKeysShortcut=0;
            }
            else
            {
                if (!m_DisableKeysWindows)
                    HandleCommand(IDM_DISABLEKEYSWINDOWS);
                m_DisableKeysBreak=1;
                m_DisableKeysEscape=1;
                m_DisableKeysShortcut=1;
            }
            UpdateDisableKeysMenu();
            break;
    }
    
    SetSound(UNMUTED);
    if (palette_type != prev_palette_type)
    {
        CreateBitmap();
        UpdateMonitorMenu();
    }
}


void BeebWin::Focus(bool gotit)
{
    if (gotit && m_TextViewEnabled)
    {
        SetFocus(m_hTextView);
    }
}



/****************************************************************************/
/* Selection of User Data Folder */
static char szExportUserDataPath[MAX_PATH];

int CALLBACK BrowseUserDataCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
    switch (uMsg)
    {
        case BFFM_INITIALIZED:
            if (szExportUserDataPath[0])
            {
                SendMessage(hwnd, BFFM_SETEXPANDED, TRUE, (LPARAM)szExportUserDataPath);
                SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)szExportUserDataPath);
            }
            break;
    }
    return 0;
}

/****************************************************************************/
bool BeebWin::RegCreateKey(HKEY hKeyRoot, LPSTR lpSubKey)
{
#if 0
    bool rc = false;
    HKEY hKeyResult;
    if ((RegCreateKeyEx(hKeyRoot, lpSubKey, 0, NULL, 0, KEY_ALL_ACCESS,
                        NULL, &hKeyResult, NULL)) == ERROR_SUCCESS)
    {
        RegCloseKey(hKeyResult);
        rc = true;
    }
    return rc;
#endif
    return false;
}

bool BeebWin::RegGetBinaryValue(
                                HKEY hKeyRoot, LPSTR lpSubKey, LPSTR lpValue, PVOID pData, int* pnSize)
{
    bool rc = false;
    HKEY hKeyResult;
    DWORD dwType = REG_BINARY;
    DWORD dwSize = *pnSize;
    LONG lRes = 0;
    
    if ((RegOpenKeyEx(hKeyRoot, lpSubKey, 0, KEY_ALL_ACCESS, &hKeyResult)) == ERROR_SUCCESS)
    {
        lRes = RegQueryValueEx(hKeyResult, lpValue, NULL, &dwType, (LPBYTE)pData, &dwSize);
        if (lRes == ERROR_SUCCESS && dwType == REG_BINARY)
        {
            *pnSize = dwSize;
            rc = true;
        }
        RegCloseKey(hKeyResult);
    }
    
    return rc;
}

bool BeebWin::RegSetBinaryValue(
                                HKEY hKeyRoot, LPSTR lpSubKey, LPSTR lpValue, PVOID pData, int* pnSize)
{
    bool rc = false;
    HKEY hKeyResult;
    DWORD dwSize = *pnSize;
    LONG  lRes = 0;
    
    if ((RegOpenKeyEx(hKeyRoot, lpSubKey, 0, KEY_ALL_ACCESS, &hKeyResult)) == ERROR_SUCCESS)
    {
        lRes = RegSetValueEx(hKeyResult, lpValue, 0, REG_BINARY, reinterpret_cast<BYTE*>(pData), dwSize);
        if (lRes == ERROR_SUCCESS)
        {
            *pnSize = dwSize;
            rc = true;
        }
        RegCloseKey(hKeyResult);
    }
    
    return rc;
}

bool BeebWin::RegGetStringValue(
                                HKEY hKeyRoot, LPSTR lpSubKey, LPSTR lpValue, LPSTR pData, DWORD dwSize)
{
    bool rc = false;
    HKEY hKeyResult;
    DWORD dwType = REG_SZ;
    LONG lRes = 0;
    
    if ((RegOpenKeyEx(hKeyRoot, lpSubKey, 0, KEY_ALL_ACCESS, &hKeyResult)) == ERROR_SUCCESS)
    {
        lRes = RegQueryValueEx(hKeyResult, lpValue, NULL, &dwType, (LPBYTE)pData, &dwSize);
        if (lRes == ERROR_SUCCESS && dwType == REG_SZ)
        {
            rc = true;
        }
        RegCloseKey(hKeyResult);
    }
    
    return rc;
}

bool BeebWin::RegSetStringValue(
                                HKEY hKeyRoot, LPSTR lpSubKey, LPSTR lpValue, LPSTR pData)
{
    bool rc = false;
    HKEY hKeyResult;
    DWORD dwSize = (DWORD)strlen(pData);
    LONG  lRes = 0;
    
    if ((RegOpenKeyEx(hKeyRoot, lpSubKey, 0, KEY_ALL_ACCESS, &hKeyResult)) == ERROR_SUCCESS)
    {
        lRes = RegSetValueEx(hKeyResult, lpValue, 0, REG_SZ, reinterpret_cast<BYTE*>(pData), dwSize);
        if (lRes == ERROR_SUCCESS)
        {
            rc = true;
        }
        RegCloseKey(hKeyResult);
    }
    
    return rc;
}

